_copyright="""
Copyright 2007 Tasci Synx

    This file is part of imageTagger.

    imageTagger is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    imageTagger is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

from urlparse import urlparse,urlunparse
from alwaysUnicode import alwaysUnicode

class URL:
	__slots__ = ('scheme', 'netloc', 'path', 'params', 'query', 'fragment')
	def __init__(self, url, scheme='', allow_fragments=1):
		url = alwaysUnicode(url)
		record = urlparse(url,scheme,allow_fragments)
		for i in range(len(self.__slots__)):
			key = self.__slots__[i]
			val = record[i]
			setattr(self,key,val)
	def unparse(self):
		return urlunparse([getattr(self,key) for key in self.__slots__])
	def __repr__(self):
		ret = u'<url '
		for key in self.__slots__:
			ret += u' '+key+u'=>"'+getattr(self,key)+u'"'
		ret += u'>'
		return ret
	def __unicode__(self):
		return self.unparse()

