_copyright="""
Copyright 2007 Tasci Synx

    This file is part of imageTagger.

    imageTagger is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    imageTagger is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import config

import os
import base64

from shutil import copyfileobj

class Spool:
	def __init__(self,loc=config.subfile('spool'),num=128):
		try: os.makedirs(loc)
		except OSError: pass
		self.num = num
		self.loc = loc
	def getName(self,uri):
		hash = base64.b64encode(uri)
		loc = os.path.join(self.loc,hash[2:],hash[2:4])
		name = os.path.join(loc,hash[4:])
		return hash,loc,name
	def dump(self,uri,type,content):
		destHash,destLoc,destName = self.getName(uri)
	
		try: os.makedirs(destLoc)
		except OSError: pass
		dest = open(destName,'w')
		try:
			dest.write(type+'\n')
			try:
				os.rename(content.name,destName+'c')
			except (AttributeError,OSError):
				destc = open(destName+'c','w')
				try: copyfileobj(content,destc)
				finally: destc.close()

			try:
				content.close()
			except OSError: pass
#			while 1:
#				buf = content.read(4096)
#				print "Beep",content
#				if not buf: break
#				dest.write(buf)
		finally:
			dest.close()
		record = open(os.path.join(self.loc,'record'),'a')
		record.write(uri+'\n')
		self.clean()
	def load(self,uri):
		srcHash,srcLoc,srcName = self.getName(uri)
		src = open(srcName)

		type = src.readline()[:-1]
		content = open(srcName+'c')
		return type,content.read() # XXX: good for database.py the .read()
	def getRecords(self):
		return [line.rstrip() for line in open(os.path.join(self.loc,'record')).readlines()]
	def clean(self):
		records = self.getRecords()
		keep,delete = records[-self.num:],records[:-self.num]
		print "Deleting",len(delete)
		for deluri in delete:
			delHash,delLoc,delName = self.getName(deluri)
			try:
				os.unlink(delName)
				os.unlink(delName+'c')
				os.removedirs(delLoc)
			except OSError: pass
		out = open(os.path.join(self.loc,'record'),'w')
		try:
			for uri in keep:
				out.write(uri+'\n')
		finally:
			out.close()
