_copyright="""
Copyright 2007 Tasci Synx

    This file is part of imageTagger.

    imageTagger is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    imageTagger is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import Image
import PngImagePlugin
import os,tempfile,shutil

def add(image,tags):
	info = PngImagePlugin.PngInfo()
	tagstr = u','.join(tags)
	tagstr = tagstr.encode('utf8')
	info.add_text('Tags', tagstr, zip=0)

	dir = os.path.dirname(image)

	img = Image.open(image)
	fd,temp = tempfile.mkstemp(dir=dir,suffix='.png')
	try:
		img.save(temp,pnginfo=info)
		shutil.copystat(image,temp)
		os.rename(temp,image)
	finally:
		os.close(fd)
		try:
			os.remove(temp)
		except OSError: pass

