_copyright="""
Copyright 2007 Tasci Synx

    This file is part of imageTagger.

    imageTagger is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    imageTagger is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import database

from cStringIO import StringIO

import Image
import GifImagePlugin
import PngImagePlugin
import JpegImagePlugin

import math

thumbSize = 128
# Thumbs will all have the same area, thumbSize**2
# A bounding box would align better, maybe use that...

def thumb(data,mime):
	type = ''
	for type,v in Image.MIME.items():
		if mime == v: break
	f = StringIO(data)
	image = Image.open(f)
	width,height = image.size
	factor = math.sqrt(width * height) / thumbSize
	if factor > 1:
		width /= factor;
		height /= factor;
		if width<thumbSize/4: width = max(width,thumbSize/4);
		elif width>thumbSize*4: width = thumbSize*4
		if height<thumbSize/4: height = thumbSize/4;
		elif height>thumbSize*4: height = thumbSize*4
		width = int(width)
		height = int(height)
	mode = Image.ANTIALIAS
	image = image.resize((width,height),mode)
	if image.mode not in ("L","RGB","CMYK"):
		image = image.convert('RGB')
	buf = StringIO()
	image.save(buf, "JPEG",optimize=True,quality=50,progressive=True)
	return buf.getvalue()
