_copyright="""
Copyright 2007 Tasci Synx

    This file is part of imageTagger.

    imageTagger is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    imageTagger is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

from subprocess import Popen
import os,sys,signal,time
oj = os.path.join

class launch:
	def __init__(self):
		self.top = os.path.dirname(sys.argv[0])
		self.action = ''
		oldchld = signal.signal(signal.SIGCHLD,self.reconnect)
		oldkill = signal.signal(signal.SIGTERM,self.terminate)
		signal.signal(signal.SIGINT,self.terminate)
		signal.signal(signal.SIGQUIT,self.terminate)
		proxy = self.launch('proxy')
		main = self.launch('main')
		while 1: 
			signal.pause()
			if self.action == 'reconnect':
				time.sleep(1)
				if self.pidLost == proxy.pid:
					proxy = self.launch('proxy')
				elif self.pidLost == main.pid:
					main = self.launch('main')
			elif self.action == 'terminate':
				signal.signal(signal.SIGCHLD,oldchld)
				signal.signal(signal.SIGTERM,oldkill)
				signal.signal(signal.SIGINT,oldkill)
				signal.signal(signal.SIGQUIT,oldkill)
				for ded in (main,proxy):
					try:
						os.kill(ded.pid,signal.SIGTERM)
						ded.wait()
					except OSError: pass
				raise SystemExit
	def launch(self,who):
		return Popen(["python",oj(self.top,who+'.py')]+sys.argv[1:])
	def reconnect(self,sig,action):
		pid,status = os.wait()
		self.action = 'reconnect'
		self.pidLost = pid
	def terminate(self,sig,action):
		self.action = 'terminate'

if __name__=='__main__':
	launch()
