_copyright="""
Copyright 2007 Tasci Synx

    This file is part of imageTagger.

    imageTagger is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    imageTagger is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import os,shutil
oj = os.path.join

pythonfiles = list()

for top,dirs,files in os.walk('.'):
	top = top[1:]
	if top and top[0]=='/':
		top = top[1:]

	for f in files:
		if not f.endswith('.py'): continue
		f = oj(top,f)
		pythonfiles.append(f)

pythonfiles.extend((
	"Dependencies",
	"README",
	"INSTALL",
	"COPYING",
	"test.py",
	"maketarball.py",
))

pythonfiles.extend((
	"taggers/wrjpgcom.c",
	"taggers/SConstruct"
))

for resource in os.listdir('resources'):
	pythonfiles.append(oj('resources',resource))

print "\n".join(pythonfiles)

exportDir = 'imageTagger-0.1'

for src in pythonfiles:
	dst = oj(exportDir,src)
	try:
		os.makedirs(os.path.dirname(dst))
	except OSError: pass
	src = os.path.abspath(src)
	try:
		os.symlink(src,dst)
	except OSError:pass
from subprocess import call
import shutil
call(["tar",'hcjf','imageTagger.tar.bz2',exportDir])
shutil.rmtree(exportDir)
