_copyright="""
Copyright 2007 Tasci Synx

    This file is part of imageTagger.

    imageTagger is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    imageTagger is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import os,tempfile,shutil
from ctypes import cdll,pointer

import sys,os
selfLocation = os.path.dirname(sys.modules[__name__].__file__)

wrjpg = cdll.LoadLibrary(os.path.join(selfLocation,'libwrjpgcom.so'))

class JPEGError(Exception): pass

def errcheck(result, func, args):
	if result==0: raise JPEGError("Could not add a comment!")

wrjpg.addComment.errcheck = errcheck

def add(image,tags):
	d = os.path.dirname(image)
	fd,temp = tempfile.mkstemp(dir=d,suffix='.jpg')
	input = os.open(image,os.O_RDONLY)
	try:
		comment = u','.join(tags)
		comment = comment.encode('utf8')
		wrjpg.addComment(input,fd,comment,len(comment),True)
		shutil.copystat(image,temp)
		os.rename(temp,image)
	finally:
		os.close(fd)
		os.close(input)
		try: 
			os.unlink(temp)
		except OSError: pass

